//-------------------------------------------------------------
// File: main.h
//
// Desc: CN_O
//-------------------------------------------------------------
#pragma once



//-------------------------------------------------------------
// `萔
//-------------------------------------------------------------
// ݂̓̓f[^ۑ\
struct UserInput
{
    BOOL bRotateUp;
    BOOL bRotateDown;
    BOOL bRotateLeft;
    BOOL bRotateRight;
    BOOL bZoomIn;
    BOOL bZoomOut;
	BOOL bSizeUp;
	BOOL bSizeDown;
};




//-------------------------------------------------------------
// Name: class CMyD3DApplication
// Desc: AvP[ṼNX
//-------------------------------------------------------------
class CMyD3DApplication : public CD3DApplication
{
	CD3DMesh				*m_pMesh;
	CD3DMesh				*m_pMeshBg;
	FLOAT					m_size;			// ڂ
			
	// VF[_
	LPD3DXEFFECT		    m_pEffect;		// GtFNg
	D3DXHANDLE				m_hTechnique;	// eNjbN
	D3DXHANDLE				m_htSrcMap;		// eNX`
	D3DXHANDLE				m_htWeightMap;	// d݂^eNX`

	// _O^[Qbg
	LPDIRECT3DSURFACE9		m_pMapZ;		// [xobt@
	LPDIRECT3DTEXTURE9		m_pSatTex;		// SATeNX`
	LPDIRECT3DSURFACE9		m_pSatSurf;		// SATT[tFX
	LPDIRECT3DTEXTURE9		m_pWeightTex;	// d݃eNX`

	// ʏ̍Wϊs
	D3DXMATRIX				m_mWorld;
	D3DXMATRIX				m_mView;
	D3DXMATRIX				m_mProj;

	BOOL					m_bLoadingApp;	// [hH
    CD3DFont*				m_pFont;		// tHg
    UserInput				m_UserInput;	// ̓f[^

    FLOAT                   m_fWorldRotX;   // w]
    FLOAT                   m_fWorldRotY;   // x]
    FLOAT                   m_fViewZoom;    // _̋

protected:
    virtual HRESULT OneTimeSceneInit();
    virtual HRESULT InitDeviceObjects();
    virtual HRESULT RestoreDeviceObjects();
    virtual HRESULT InvalidateDeviceObjects();
    virtual HRESULT DeleteDeviceObjects();
    virtual HRESULT Render();
    virtual HRESULT FrameMove();
    virtual HRESULT FinalCleanup();
    virtual HRESULT ConfirmDevice( D3DCAPS9*, DWORD, D3DFORMAT );

    HRESULT RenderText();

    void    UpdateInput( UserInput* pUserInput );
	void    UpdateParam();
public:
    LRESULT MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
    CMyD3DApplication();
    virtual ~CMyD3DApplication();
};

